#include "libnazgul.h"
#include "ids.h"

int msgQueueReadTryLock(msgSpaceId externId,int queueIdx){
  sem_t * queueSemFd;
  msgQueueSemId queueSemId;

  msgQueueReadSemIdIntern(queueSemId,externId,queueIdx);
  queueSemFd=sem_open(queueSemId,O_CREAT,SEM_DEFAULT_MODE,1);
  if(queueSemFd==SEM_FAILED){
	NZG_ERROR("sem_open",queueSemId);
	goto ERROR;
  }

  if(sem_trywait(queueSemFd)==-1){
	NZG_ERROR("sem_wait",queueSemId);
	goto ERROR;
  }
  printf("Locking %s\n",queueSemId);
  int semval=0;
 sem_getvalue(queueSemFd,&semval);
 printf("(AfterValue:%d)\n",semval);

  sem_close(queueSemFd);


  sem_close(queueSemFd);

  return 0;
ERROR:
  return -1; 
}

