#include "libnazgul.h"
#include "ids.h"


int msgPoolDataTabUnlock(msgSpace * space){
  sem_t * poolDataTabSemFd;
printf("Unlocking %s\n",space->poolDataTabSemId);
 poolDataTabSemFd=sem_open(
	  space->poolDataTabSemId
	  ,O_CREAT,
	  SEM_DEFAULT_MODE,
	  1);
  if(poolDataTabSemFd==SEM_FAILED){
	NZG_ERROR("sem_open",space->poolDataTabSemId);
	goto ERROR;
  }

  if(sem_post(poolDataTabSemFd)==-1){
	NZG_ERROR("sem_post",space->poolDataTabSemId);
	goto ERROR;
  }
 int semval=0;
 sem_getvalue(poolDataTabSemFd,&semval);
 printf("(AfternValue:%d)\n",semval);

  sem_close(poolDataTabSemFd);

  return 0;
ERROR:
  return -1; 
}

